function folderListNew  = ListOfFoldersWhichDoNotIncludeParticularFileOrSubFolder( folderPathNameWithSubFoldersToLookAt,FileOrFolderNameToBeLookedForInSubfolders )
% folderListNew  = ListOfFoldersWhichDoNotIncludeParticularFileOrSubFolder( folderPathNameWithSubFoldersToLookAt,FileOrFolderNameToBeLookedForInSubfolders )
% Outputs list of subfolders locateed in folder "folderPathNameWithSubFoldersToLookAt", with the condition that the subfolders does not include the particular file name "FileNameToBeLookedFor"
% Outputs
%   folderListNew                           Dir Structure of list of folders 
% Inputs
%   folderPathNameWithSubFoldersToLookAt    folder path name with subfolders to look at
%   FileNameToBeLookedForInSubfolders       File or folder name to be looot as fileked for and for which the parent folder is removed from the list of subfolders
%                                           Folder name should include the '/' at the end to be recognized as folder and n    
% 
% Exemples:
% If all subfolders without any folder is to be removed, just set
% FileOrFolderNameToBeLookedForInSubfolders='*/'
% If all subfolders containing files starting by  COUCOU and ending by HIBOU.csv should be removed, just set FileOrFolderNameToBeLookedForInSubfolders='COUCOU*HIBOU.csv'

% option for function 'keepOnlyFilesAndFolders'
if FileOrFolderNameToBeLookedForInSubfolders(end)=='/' % folder
    excludeFiles=1;
else % file
    excludeFiles=2;
end

folderList=keepOnlyFilesAndFolders(dir(folderPathNameWithSubFoldersToLookAt),1);
folderListNew=[];
folderListNew_index=1;    
for folderList_index=1:length(folderList) 
    files=keepOnlyFilesAndFolders(dir(strcat(folderPathNameWithSubFoldersToLookAt, folderList(folderList_index).name,FileOrFolderNameToBeLookedForInSubfolders)),excludeFiles);
    if isempty(files)==0
        if folderList_index==1
            folderListNew = folderList(folderList_index);
        else
            folderListNew(folderListNew_index) = folderList(folderList_index);
        end
        folderListNew_index=folderListNew_index+1;
    end
end     


