function plotSoundStimShapeAndXYZpos(data,VidData_name,fig_print,figFolderPath,title_mess,fig_close,folderName_v,folder_main)
% For PlaybackExp_analysis.m code
% Plot sound, stim shape, X, Y, Z
% 1 figure for each replicate
% Inputs:
% data              data sructure
% VidData_name    string. NAme of the structure field to plotted
% fig_print         1 or 0
% figFolderPath     Figure folder path
% title_mess        MEssage in the title of the figures
% fig_close         1 or 0
% folderName_v      REplicates to be processsed
% folder_main       Main folder


Nfeatures=4; % Number of columns (audio, XYZ)
fs=data(1).fs;
ylim_sound=0.15;
ylim_xyz=0.9;


% We remove the folders without data (i.e. without folder inside)
folderName  = ListOfFoldersWhichDoNotIncludeParticularFileOrSubFolder( ...
                        folder_main,...
                        '*/' );      
for foldNam_ind=folderName_v
    disp(['   Replicate from file ' num2str( foldNam_ind) '/' num2str(length(folderName)) ' ' folderName(foldNam_ind).name]);

    % We remove the folders without .csv files (i.e. with the video only)
    folderNameTrackit  = ListOfFoldersWhichDoNotIncludeParticularFileOrSubFolder( ...
                            strcat(folder_main,folderName(foldNam_ind).name,'/trackit/'),...
                            '/PostProc_Filtered_*Splined.csv' );    
    
    figure
    for foldNamTrac_ind=1:length(folderNameTrackit)
        for features_i=1:Nfeatures % i.e. x, y, z  
             subplot_index=mod(foldNamTrac_ind,length(folderNameTrackit)+1)+ (features_i-1)*length(folderNameTrackit);
             axis_subp(subplot_index) = subplot( Nfeatures, length(folderNameTrackit),  subplot_index);%,0.01,0.1,0.1 );
        end
    end
          
    % Stim shape
    stim_v=data(foldNam_ind).stim_v;

    for foldNamTrac_ind=1:length(folderNameTrackit) 
        disp(['      Subreplicate ' num2str( foldNamTrac_ind) '/' num2str(length(folderNameTrackit) ) ]);
       
        sound_subreplicate= data(foldNam_ind).subrep(foldNamTrac_ind).sound;
        time_soundSubreplicate=(0:length(sound_subreplicate)-1)/fs;

        subplot_index=mod(foldNamTrac_ind,length(folderNameTrackit)+1) ;
        plot(axis_subp(subplot_index),time_soundSubreplicate ,sound_subreplicate);

        for stim_v_ind=1:size(stim_v,1)
            hold(axis_subp(subplot_index),'on'), 
            plot(axis_subp(subplot_index),...                   
                    [data(foldNam_ind).stim_v(stim_v_ind,1)-1/fs , data(foldNam_ind).stim_v(stim_v_ind,:), data(foldNam_ind).stim_v(stim_v_ind,2)+1/fs ],...
                   [0 , ones(1,2) , 0]*max(sound_subreplicate),'k');  
        end   
        ylim(axis_subp(subplot_index),[-ylim_sound ylim_sound])
        
        % video data
        VidData = data(foldNam_ind).subrep(foldNamTrac_ind).(VidData_name);
        % VidData = data(foldNam_ind).subrep(foldNamTrac_ind).VidData_contrSwarm;
        if isempty(VidData)==1 || all(isnan(data(foldNam_ind).subrep(foldNamTrac_ind).timeTrackSynch_sec))==1
            disp(['         Empty Video or no good synchronization flag available']);
        else
            % Shoul be the same than unique(data(foldNam_ind).subrep(foldNamTrac_ind).VidData_sync(:,2))

            legend_name=[];
            object_v=unique(VidData(:,1))';
            for object_index = object_v
                %disp(['       object ' num2str(object_index) '/' num2str(length(object_v))])
                row= VidData(:,1)==object_index;
                if length(num2str(VidData(row(1),1)))==3
                    legend_name=[legend_name ; ['Tracking ', num2str(VidData(row(1),1))] ];
                elseif length(num2str(VidData(row(1),1)))==2
                    legend_name=[legend_name ; ['Tracking 0',num2str(VidData(row(1),1))]];
                elseif length(num2str(VidData(row(1),1)))==1
                    legend_name=[legend_name ; ['Tracking 00',num2str(VidData(row(1),1))]];
                end

                for features_i=2:Nfeatures % i.e. sound, x, y, z    %%% Can be very long to compute I dont know why (like 20sec per loop)
               
                    subplot_index=mod(foldNamTrac_ind,length(folderNameTrackit)+1)+ (features_i-1)*length(folderNameTrackit);
                    der=1; % 1= position, 2= position'(t)

                    hold(axis_subp(subplot_index),'on'), 
                    plot(axis_subp(subplot_index),VidData(row,2),VidData(row,2+(features_i-1)+3*(der-1)),...
                    '.','markersize', 1);%,'color',color_map(object_index,:) );  % X(t) , Y(t), Z(t)
                end
            end
        end
    end
    
    % Label
    disp('      Plot label and saving');

    ylabel(axis_subp(1),'Sound pressure');
    subplot(  Nfeatures, length(folderNameTrackit),1+length(folderNameTrackit)*1), ylabel ('X (m)');
    subplot(  Nfeatures, length(folderNameTrackit),1+length(folderNameTrackit)*2), ylabel ('Y (m)');
    subplot(  Nfeatures, length(folderNameTrackit),1+length(folderNameTrackit)*3), ylabel ('Z (m)');
    for subplot_index=1: length(folderNameTrackit)
        foldNamTrac_ind=subplot_index;
        title(axis_subp(subplot_index),{['subrep ' num2str(foldNamTrac_ind)],[folderNameTrackit(foldNamTrac_ind).name(12:13),'h',...
         folderNameTrackit(foldNamTrac_ind).name(15:16),'m',...
         folderNameTrackit(foldNamTrac_ind).name(18:end) ]},...
         'fontSize',5);
    end
    
    for foldNamTrac_ind=1:length(folderNameTrackit) 
            
            for features_i=1:Nfeatures % i.e. x, y, z  
                subplot_index=mod(foldNamTrac_ind,length(folderNameTrackit)+1)+ (features_i-1)*length(folderNameTrackit);
               
                if subplot_index <= (Nfeatures-1)* length(folderNameTrackit)
                    set(axis_subp(subplot_index),'xticklabel',{[]})
                end
                if mod(subplot_index,length(folderNameTrackit)) ~=1
                    set(axis_subp(subplot_index),'yticklabel',{[]})
                end
                
                if isempty(data(foldNam_ind).subrep(foldNamTrac_ind).VidData_sync)==0
                    xlim(axis_subp(subplot_index),[0 (length(data(foldNam_ind).subrep(foldNamTrac_ind).sound)-1)/fs]) ;
                    if subplot_index>foldNamTrac_ind
                        ylim(axis_subp(subplot_index),[-ylim_xyz ylim_xyz])
                    end
                end

            end
                      
    end
                        
    suplabel('Features','y');
    suplabel('Time (sec)','x');
    suplabel([ num2str(foldNam_ind) '/' num2str(length(folderName))...
        '  ' data(foldNam_ind).sex ' ' data(foldNam_ind).date...
        ' ' data(foldNam_ind).day...
        ' ' title_mess]...
        ,'t');
    set(gcf,'Units','Inches');
    pos = get(gcf,'Position');
    set(gcf,'PaperPositionMode','Auto','PaperUnits','Inches','PaperSize',[pos(3), pos(4)])
    clo=clock;
    heure=[num2str(clo(4)) 'h'];
    min=[num2str(clo(5)) 'm'];
    time=[ heure '-' min];
    if fig_print==1
        print(gcf,strcat(figFolderPath,folderName(foldNam_ind).name,'_',VidData_name,'_',date,'-',time ,'.pdf'),'-dpdf','-r0')   
    end
    if fig_close==1
        close
    end
end
